package oldcore.calc.census;

import java.util.Set;



public class ClusterCircuitFinder {
	
	public ClusterCircuitFinder (ClusterNetwork network){
		
	}
	

	/**
	 * effectuates a connubial census (counts the connubial circuits in an alliance network)
	 * <p> counts the numbers of 1. endogamous marriages, 2. double marriages, 3. exchange marriages, 4. triadic marriage cycles
	 * @return the census map
	 * @see trash.Part#getCensuses(Net)
	 */
	public void findCircuits (){

    	for (GroupNode v: values()){
    		v.setDegrees();
    	}
    	for (GroupNode v: values()){
    		if (v.getID()==0) continue;
    		int r = value(v,v); 
    		int r2= pValue(v,v);
    		if (r>0) {
    			VertexChain<GroupNode> c0 = new VertexChain<GroupNode>(v);
    			c0.setValue(r);
    			c0.setType(r2);
    			c0.setLabel(r+" ");
    			census.add("1. "+clu(0),c0);
    		}
   			Set<GroupNode> allies = v.getTakers();
   			if (allies==null) continue; 
   			for (GroupNode w : allies) {
   				if (w.getID()==0) continue;
    			if (w==v) continue;
    			r = value(v,w);
    			r2 = pValue(v,w);
        		if (r>1) {
        			VertexChain<GroupNode> c1 = new VertexChain<GroupNode>(v,w);
        			c1.setValue(r*(r-1)/2);
        			c1.setType(r2*(r2-1)/2);
        			c1.setLabel(r+" ");
        			census.add("2. "+clu(1), c1);
        		}
        		int s = value(w,v); 
        		int s2 = pValue(w,v); 
        		if (s>0 && r>0) {
        			VertexChain<GroupNode> c2 = new VertexChain<GroupNode>(v,w);
        			c2.setValue(r*s);
        			c2.setType(r2*s2);
        			c2.setLabel(r+" "+s);
        			census.add("3. "+clu(2), c2);
    			}
        		Set<GroupNode> allies2 = w.getTakers();
       			if (allies2==null) continue; 
       			for (GroupNode u : allies2) {
       				if (u.getID()==0) continue;
        			if (u==w || u==v) continue;
        			s = value(w,u);
        			s2 = pValue(w,u);
        			if (s==0 || r==0) continue;
        			int t = value(u,v);
        			int t2 = pValue(u,v);
            		if (t>0) {
            			VertexChain<GroupNode> c2 = new VertexChain<GroupNode>(v,w,u);
            			c2.setValue(r*s*t);
            			c2.setType(r2*s2*t2);
            			c2.setLabel(r+" "+s+" "+t);
            			census.add("4. "+clu(3), c2);
        			}
       			}
    		}
    	}
    	return census;
    }

}
