package org.tip.puck.net.relations;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

/**
 * 
 * @author TIP
 */
public class Actors extends ArrayList<Actor> {

	private static final long serialVersionUID = -1258074052306152168L;

	/**
	 * 
	 */
	public Actors() {
		super();
	}

	/**
	 * 
	 */
	public Actors(final Actors source) {
		super(source);
	}

	/**
	 * 
	 * @param id
	 * @return
	 */
	public Actors getById(final int id) {
		Actors result;

		result = new Actors();
		for (Actor actor : this) {
			if (actor.getId() == id) {
				result.add(actor);
			}
		}

		//
		return result;
	}

	/**
	 * 
	 * @param id
	 * @return
	 */
	public Actors getByRole(final Role role) {
		Actors result;

		result = new Actors();
		for (Actor actor : this) {
			if (actor.getRole() == role) {
				result.add(actor);
			}
		}

		//
		return result;
	}

	/**
	 * 
	 * @param id
	 * @return
	 */
	public Actors getByRole(final String role) {
		Actors result;

		result = new Actors();
		for (Actor actor : this) {
			if (StringUtils.equals(actor.getRole().getName(), role)) {
				result.add(actor);
			}
		}

		//
		return result;
	}

	/**
	 * 
	 * @param id
	 * @return
	 */
	public Actors getOthers(final int id) {
		Actors result;

		result = new Actors();
		for (Actor actor : this) {
			if (actor.getId() != id) {
				result.add(actor);
			}
		}

		//
		return result;
	}

	/**
	 * 
	 * @param id
	 * @return
	 */
	public boolean hasActor(final int id) {
		boolean result;

		boolean ended = false;
		result = false;
		Iterator<Actor> iterator = this.iterator();
		while (!ended) {
			if (iterator.hasNext()) {
				Actor actor = iterator.next();
				if (actor.getId() == id) {
					ended = true;
					result = true;
				}
			} else {
				ended = true;
				result = false;
			}
		}

		//
		return result;
	}

	/**
	 * 
	 * @param id
	 * @param role
	 * @return
	 */
	public boolean hasActor(final int id, final String role) {
		boolean result;

		boolean ended = false;
		result = false;
		Iterator<Actor> iterator = this.iterator();
		while (!ended) {
			if (iterator.hasNext()) {
				Actor actor = iterator.next();
				if ((actor.getId() == id) && (StringUtils.equals(actor.getRole().getName(), role))) {
					ended = true;
					result = true;
				}
			} else {
				ended = true;
				result = false;
			}
		}

		//
		return result;
	}

	/**
	 * 
	 * @return
	 */
	public List<Actor> toList() {
		List<Actor> result;

		result = new ArrayList<Actor>(this.size());
		for (Actor actor : this) {
			result.add(actor);
		}

		//
		return result;
	}
}
